!! module to implement crossover options for mating

module ga_crossover
	use ga_aux

	implicit none

	contains
	!-------------------------------------------------------------------
	subroutine crossover(ncross,j,mate1,mate2,nparam,npopsiz,nchrome, &
		& nchild,iunifrm,pcross,iparent,ichild)
	!-------------------------------------------------------------------
	! Subroutine for crossover between the randomly selected pair.
	!-------------------------------------------------------------------

		!! subroutine arguments
		integer, intent(inout)	:: ncross 
		integer, intent(in)		:: j 
		integer, intent(in)		:: nparam
		integer, intent(in)		:: npopsiz
		integer, intent(in)		:: nchrome
		integer, intent(in)		:: iunifrm
		integer, intent(in)		:: mate1
		integer, intent(in)		:: mate2
		integer, intent(in)		:: nchild
		real, intent(in)		:: pcross
		integer, dimension(nchrome,npopsiz), intent(inout) :: ichild
		integer, dimension(nchrome,npopsiz), intent(inout) :: iparent

		!! local variables
		integer :: n
		integer	:: icross	! the crossover point in single-point crossover
		real :: rand
	
		ncross=0
		if (iunifrm == 0) then

			! Single-point crossover at a random point in the chromosome
			call ran3(1,rand)
			if(rand > pcross) return
			ncross=ncross+1
			call ran3(1,rand)
			icross=2+dint(dble(nchrome-1)*rand)
			do n=icross,nchrome
				ichild(n,j)=iparent(n,mate2)
				if(nchild == 2) ichild(n,j+1)=iparent(n,mate1)
			end do
		else

			! Uniform crossover between the randomly selected pair.
			do n=1,nchrome
				call ran3(1,rand)
				if(rand <= pcross) then
					ncross=ncross+1
					ichild(n,j)=iparent(n,mate2)
					if(nchild == 2) ichild(n,j+1)=iparent(n,mate1)
				endif
			end do
		end if

		return
	end subroutine crossover
	!--------------------------------------------------------------------------

end module ga_crossover
